
#include <FastSPI_LED2.h>
#include <Conceptinetics.h>
// ****************************************************************************************
// ****************************************************************************************

// Configure DMX start Address
#define DMX_START_CHANNEL   1 

// How many strobes in the string?
#define STROBES 50

// How many milliseconds do you want the strobes to be on for?
#define SPEED 20   // I personally wouldn't use any value less than 10 or more than 100

// How many strobes on at any one time?
#define TOTAL 10

// ****************************************************************************************
// ****************************************************************************************

#define DMX_SLAVE_CHANNELS   1 
// How old are you? 
#define AGE 20 // Changes strobe pattern just in case you want a different pattern for whatever reason so feel free to lie about your age ;)
// Data pin (Blue wire from strobes)

#define DATA_PIN 3  // !!!!!DO NOT USE PINS 0 or 1!!!!!







CRGB leds[STROBES];
int strobe;
int trigger;
int data[TOTAL];
unsigned long       lastFrameReceivedTime;
const unsigned long dmxTimeoutMillis = 10000UL;
DMX_Slave dmx_slave ( DMX_SLAVE_CHANNELS );

void setup() {
    dmx_slave.enable ();
    dmx_slave.setStartAddress (DMX_START_CHANNEL);
    dmx_slave.onReceiveComplete ( OnFrameReceiveComplete );
  FastLED.addLeds<WS2811, DATA_PIN, RGB>(leds, STROBES);
  randomSeed(AGE);
}

void loop() {
   unsigned long now = millis();
   if ( now - lastFrameReceivedTime > dmxTimeoutMillis )    dmx_slave.getBuffer().clear();
   if ( dmx_slave.getChannelValue (1) > 127 )   trigger = LOW;  else trigger = HIGH;
  if (trigger == LOW) {
    for(int count = 0; count < TOTAL; count = count + 1) {
      strobe = random(STROBES);
      data[count] = strobe;
      leds[strobe] = CRGB::White;  
      FastLED.show();
    }
//SPEED == dmx_slave.getChannelValue(2)/2;
    delay(SPEED);
  }
  for(int count = 0; count < TOTAL; count = count + 1) {
    strobe = data[count];
    leds[strobe] = CRGB::Black;  
    FastLED.show();
  }
}

void OnFrameReceiveComplete (void)
{
  // Update receive time to determine signal timeout
  lastFrameReceivedTime = millis ();
}

